Loading...
Searching...
No Matches
Opm::BaseAquiferModel< TypeTag > Class Template Reference

The base class which specifies the API of aquifer models. More...

`#include <BaseAquiferModel.hpp>`

## Public Member Functions

| BaseAquiferModel (Simulator &simulator)
void | initialSolutionApplied ()
| Called once the problem has been fully initialized and the initial condition has been applied.
void | initFromRestart (const data::Aquifers &)
| Called if aquifers are being initialized from values retrieved from a restart file.
void | beginEpisode ()
| This method is called when a new episode (report step) starts.
void | beginTimeStep ()
| This method is called when a new time step (substep) starts.
void | beginIteration ()
| This method is called before each Newton-Raphson iteration.
template<class Context>
void | addToSource (RateVector &, const Context &, unsigned, unsigned) const
| Add the water which enters or leaves the reservoir due to aquifiers.
void | addToSource (RateVector &, unsigned, unsigned) const
void | endIteration ()
| This method is called after each Newton-Raphson successful iteration.
void | endTimeStep ()
| This method is called after each successful time step (substep).
void | endEpisode ()
| This method is called once an episode (report step) has been finished successfully.
template<class Restarter>
void | serialize (Restarter &)
| Write the internal state of the aquifer model to disk using an ad-hoc file format.
template<class Restarter>
void | deserialize (Restarter &)
| Load the internal state of the aquifer model to disk using an ad-hoc file format.
data::Aquifers | aquiferData () const

## Protected Attributes

Simulator & | simulator_

## Detailed Description

template<class TypeTag>
class Opm::BaseAquiferModel< TypeTag >

The base class which specifies the API of aquifer models.

This class only provides the API for the actual aquifer model, it does not do anything on its own.

## Member Function Documentation

## endIteration()

template<class TypeTag>

void Opm::BaseAquiferModel< TypeTag >::endIteration | ( |  | ) |

inline

This method is called after each Newton-Raphson successful iteration.

I.e., no exceptions were thrown during the linearization and linear solution procedures.

## endTimeStep()

template<class TypeTag>

void Opm::BaseAquiferModel< TypeTag >::endTimeStep | ( |  | ) |

inline

This method is called after each successful time step (substep).

I.e., all iterations of the time step were successful and the Newton-Raphson algorithm converged.

## initFromRestart()

template<class TypeTag>

void Opm::BaseAquiferModel< TypeTag >::initFromRestart | ( | const data::Aquifers & |  | ) |

inline

Called if aquifers are being initialized from values retrieved from a restart file.

Parameters

  [in] | aquiferSoln | Set of aquifer-related initial values, mostly pertaining to analytic aquifers. Contains at minimum the aquifer pressure and the base run's total produced liquid volume from the model's aquifers.

The documentation for this class was generated from the following file:

- opm/simulators/flow/BaseAquiferModel.hpp